//+------------------------------------------------------------------+
//|                                         Point&Figure text charts |
//|                                        BSD Lic. 2012, Roman Rich |
//|                                           http://www.FXRays.info |
//+------------------------------------------------------------------+
#property               copyright "Roman Rich"
#property               link      "http://www.FXRays.info"
#property               version   "1.00"
#property               script_show_inputs

input bool              mw=false;                                    //All MarketWatch?
input ENUM_TIMEFRAMES   tf=PERIOD_M1;                                //Time frame
                                                                     //input ENUM_TIMEFRAMES   tf=PERIOD_H1;                                //Time frame
input long              box=7;                                       //Box size in pips (0 - auto)
                                                                     //input long              box=1;                                       //Box size in pips (0 - auto)
enum                    cChoice{c10=10,c25=25,c50=50,c100=100};
input cChoice           count=c50;                                   //Chart height in boxes for autocharting
enum                    rChoice{Two=2,Three,Four,Five,Six,Seven};
input rChoice           reverse=Five;                                //Number of boxes for reversal
                                                                     //input rChoice           reverse=Three;                                //Number of boxes for reversal
enum                    vChoice{v10=10,v25=25,v50=50};
input vChoice           vd=v10;                                      //Characters for displaying volumes
enum                    dChoice{Little=15000,Middle=50000,Many=100000,Extremely=1000000};
input dChoice           depth=Little;                                //History depth
input int               cellsize=12;                                  // cell size in pixels
input int               startX=50;                                  // cell size in pixels

int                     mwSymb;
string                  symb;

//-- include the file containing cIntBMP class
#include <cIntBMP.mqh>
cIntBMP bmp;     // cIntBMP class instance
uchar BitMask_O[192]=
  {
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,

   255,255,255,
   136,136,136,
   26,26,26,
   3,3,3,
   51,51,51,
   181,181,181,
   255,255,255,
   255,255,255,

   177,177,177,
   39,39,39,
   213,213,213,
   255,255,255,
   204,204,204,
   45,45,45,
   160,160,160,
   255,255,255,

   117,117,117,
   143,143,143,
   255,255,255,
   255,255,255,
   255,255,255,
   234,234,234,
   30,30,30,
   221,221,221,

   179,179,179,
   79,79,79,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   145,145,145,
   113,113,113,

   253,253,253,
   41,41,41,
   190,190,190,
   255,255,255,
   255,255,255,
   255,255,255,
   185,185,185,
   77,77,77,

   255,255,255,
   217,217,217,
   32,32,32,
   158,158,158,
   253,253,253,
   253,253,253,
   128,128,128,
   83,83,83,

   255,255,255,
   255,255,255,
   226,226,226,
   90,90,90,
   11,11,11,
   7,7,7,
   62,62,62,
   219,219,219
  };

uchar BitMask_X[192]=
  {
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,
   255,255,255,

   51,51,51,
   185,185,185,
   255,255,255,
   255,255,255,
   224,224,224,
   28,28,28,
   251,251,251,
   255,255,255,

   204,204,204,
   37,37,37,
   207,207,207,
   255,255,255,
   117,117,117,
   81,81,81,
   255,255,255,
   255,255,255,

   255,255,255,
   217,217,217,
   51,51,51,
   230,230,230,
   32,32,32,
   221,221,221,
   255,255,255,
   255,255,255,

   255,255,255,
   255,255,255,
   219,219,219,
   37,37,37,
   66,66,66,
   255,255,255,
   255,255,255,
   255,255,255,

   255,255,255,
   255,255,255,
   111,111,111,
   149,149,149,
   115,115,115,
   132,132,132,
   255,255,255,
   255,255,255,

   255,255,255,
   181,181,181,
   45,45,45,
   255,255,255,
   249,249,249,
   45,45,45,
   162,162,162,
   255,255,255,

   255,255,255,
   64,64,64,
   202,202,202,
   255,255,255,
   255,255,255,
   221,221,221,
   28,28,28,
   255,255,255
  };

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int RGB256(int aR,int aG,int aB)
  {
   return(aR+256*aG+65536*aB);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ShowBitMask(int x,int y,int img)
  {

   uchar r,g,b;
   for(int i=0; i<8; i++)
     {
      for(int j=0; j<8; j++)
        {
         switch(img)
           {
            case 1:
               r=BitMask_X[3*(j*8+i)];
               g=BitMask_X[3*(j*8+i)+1];
               b=BitMask_X[3*(j*8+i)+2];
               break;
            case 2:
               r=BitMask_O[3*(j*8+i)];
               g=BitMask_O[3*(j*8+i)+1];
               b=BitMask_O[3*(j*8+i)+2];
               break;
           };
         int col=RGB256(r,g,b);
         //col=ConvertColor(col);
         bmp.DrawDot(x+i,y+j,col);
        }
     }
  }
//+------------------------------------------------------------------+
//|Instrument selection                                                 |
//+------------------------------------------------------------------+
void OnStart()
  {

   if(mw==true)
     {
      mwSymb=0;
      while(mwSymb<SymbolsTotal(true))
        {
         symb=SymbolName(mwSymb,true);
         PNF(symb);
         mwSymb++;
        };
     }
   else
     {
      symb=Symbol();
      PNF(symb);
     };

//Alert("Ok.");

   while(!IsStopped())
     {
      Sleep(100);
     }

  }
//+------------------------------------------------------------------+
//|Chart calculation and drawing                       |
//+------------------------------------------------------------------+
void PNF(string s)
  {
   string      fn;
   int         handle;
   string      ps;
   datetime    d[];
   double      o[],h[],l[],c[];
   long        v[];
   uchar       matrix[];
   long        VolByPrice[],VolByCol[],VolumeMax;
   int         tMin[],tMax[];
   datetime    DateByCol[];
   MqlDateTime bMDT,eMDT;
   string      strDBC[];
   uchar       pnf='.';
   int         sd;
   int         b,i,j;
   int         GlobalMin,GlobalMax,StartMin,StartMax,CurMin,CurMax,RevMin,RevMax,ContMin,ContMax;
   int         height,width,beg=0,end=0;
   double      dBox,price;
   int         thBeg=1,thEnd=2,tv=0;
   uchar       trend='.';
   if(SymbolInfoInteger(s,SYMBOL_DIGITS)<=3) sd=2; else sd=4;
   fn=s+"_b"+DoubleToString(box,0)+"_r"+DoubleToString(reverse,0)+".txt";
   handle=FileOpen(fn,FILE_WRITE|FILE_TXT|FILE_ANSI,';');
   b=MathMin(Bars(s,tf),depth);
   ArrayFree(d);
   ArrayFree(o);
   ArrayFree(h);
   ArrayFree(l);
   ArrayFree(c);
   ArrayFree(v);
   ArrayFree(matrix);
   ArrayFree(VolByPrice);
   ArrayFree(VolByCol);
   ArrayFree(DateByCol);
   ArrayFree(tMin);
   ArrayFree(tMax);
   ArrayResize(d,b,0);
   ArrayResize(o,b,0);
   ArrayResize(h,b,0);
   ArrayResize(l,b,0);
   ArrayResize(c,b,0);
   ArrayResize(v,b,0);
   ArrayInitialize(d,NULL);
   ArrayInitialize(o,NULL);
   ArrayInitialize(h,NULL);
   ArrayInitialize(l,NULL);
   ArrayInitialize(c,NULL);
   ArrayInitialize(v,NULL);
   CopyTime(s,tf,0,b,d);
   CopyOpen(s,tf,0,b,o);
   CopyHigh(s,tf,0,b,h);
   CopyLow(s,tf,0,b,l);
   CopyClose(s,tf,0,b,c);
   CopyTickVolume(s,tf,0,b,v);
   if(box!=0)
     {
      dBox=box/MathPow(10.0,(double)sd);
     }
   else
     {
      dBox=MathNorm((h[ArrayMaximum(h,0,WHOLE_ARRAY)]-l[ArrayMinimum(l,0,WHOLE_ARRAY)])/count,1/MathPow(10.0,(double)sd),true)/MathPow(10.0,(double)sd);
     };
   GlobalMin=MathNorm(l[ArrayMinimum(l,0,WHOLE_ARRAY)],dBox,true)-(int)(reverse);
   GlobalMax=MathNorm(h[ArrayMaximum(h,0,WHOLE_ARRAY)],dBox,false)+(int)(reverse);
   StartMin=MathNorm(l[0],dBox,true);
   StartMax=MathNorm(h[0],dBox,false);
   ContMin=(int)(StartMin-1);
   ContMax=(int)(StartMax+1);
   RevMin=(int)(StartMax-reverse);
   RevMax=(int)(StartMin+reverse);
   height=(int)(GlobalMax-GlobalMin);
   width=1;
   ArrayResize(matrix,height*width,0);
   ArrayInitialize(matrix,'.');
   ArrayResize(VolByPrice,height,0);
   ArrayInitialize(VolByPrice,0);
   ArrayResize(VolByCol,width,0);
   ArrayInitialize(VolByCol,0);
   ArrayResize(DateByCol,width,0);
   ArrayInitialize(DateByCol,D'01.01.1971');
   ArrayResize(tMin,width,0);
   ArrayInitialize(tMin,0);
   ArrayResize(tMax,width,0);
   ArrayInitialize(tMax,0);
   for(i=1;i<b;i++)
     {
      CurMin=MathNorm(l[i],dBox,true);
      CurMax=MathNorm(h[i],dBox,false);
      switch(pnf)
        {
         case '.':
           {
            if(CurMax>=RevMax)
              {
               pnf='X';
               ContMax=(int)(CurMax+1);
               RevMin=(int)(CurMax-reverse);
               beg=(int)(StartMin-GlobalMin-1);
               end=(int)(CurMax-GlobalMin-1);
               SetMatrix(matrix,beg,end,height,(int)(width-1),pnf);
               SetVector(VolByPrice,beg,end,v[i]);
               VolByCol[width-1]=VolByCol[width-1]+v[i];
               DateByCol[width-1]=d[i];
               trend='D';
               break;
              };
            if(CurMin<=RevMin)
              {
               pnf='O';
               ContMin=(int)(CurMin-1);
               RevMax=(int)(CurMin+reverse);
               beg=(int)(CurMin-GlobalMin-1);
               end=(int)(StartMax-GlobalMin-1);
               SetMatrix(matrix,beg,end,height,(int)(width-1),pnf);
               SetVector(VolByPrice,beg,end,v[i]);
               VolByCol[width-1]=VolByCol[width-1]+v[i];
               DateByCol[width-1]=d[i];
               trend='U';
               break;
              };
            break;
           };
         case 'X':
           {
            if(CurMax>=ContMax)
              {
               pnf='X';
               ContMax=(int)(CurMax+1);
               RevMin=(int)(CurMax-reverse);
               end=(int)(CurMax-GlobalMin-1);
               SetMatrix(matrix,beg,end,height,(int)(width-1),pnf);
               SetVector(VolByPrice,beg,end,v[i]);
               VolByCol[width-1]=VolByCol[width-1]+v[i];
               DateByCol[width-1]=d[i];
               break;
              };
            if(CurMin<=RevMin)
              {
               pnf='O';
               ContMin=(int)(CurMin-1);
               RevMax=(int)(CurMin+reverse);
               tMin[width-1]=beg-1;
               tMax[width-1]=end+1;
               beg=(int)(CurMin-GlobalMin-1);
               end--;
               width++;
               ArrayResize(matrix,height*width,0);
               ArrayResize(VolByCol,width,0);
               ArrayResize(DateByCol,width,0);
               ArrayResize(tMin,width,0);
               ArrayResize(tMax,width,0);
               SetMatrix(matrix,0,(int)(height-1),height,(int)(width-1),'.');
               SetMatrix(matrix,beg,end,height,(int)(width-1),pnf);
               SetVector(VolByPrice,beg,end,v[i]);
               VolByCol[width-1]=0;
               VolByCol[width-1]=VolByCol[width-1]+v[i];
               DateByCol[width-1]=d[i];
               tMin[width-1]=beg-1;
               tMax[width-1]=end+1;
               break;
              };
            break;
           };
         case 'O':
           {
            if(CurMin<=ContMin)
              {
               pnf='O';
               ContMin=(int)(CurMin-1);
               RevMax=(int)(CurMin+reverse);
               beg=(int)(CurMin-GlobalMin-1);
               SetMatrix(matrix,beg,end,height,(int)(width-1),pnf);
               SetVector(VolByPrice,beg,end,v[i]);
               VolByCol[width-1]=VolByCol[width-1]+v[i];
               DateByCol[width-1]=d[i];
               break;
              };
            if(CurMax>=RevMax)
              {
               pnf='X';
               ContMax=(int)(CurMax+1);
               RevMin=(int)(CurMax-reverse);
               tMin[width-1]=beg-1;
               tMax[width-1]=end+1;
               beg++;
               end=(int)(CurMax-GlobalMin-1);
               width++;
               ArrayResize(matrix,height*width,0);
               ArrayResize(VolByCol,width,0);
               ArrayResize(DateByCol,width,0);
               ArrayResize(tMin,width,0);
               ArrayResize(tMax,width,0);
               SetMatrix(matrix,0,(int)(height-1),height,(int)(width-1),'.');
               SetMatrix(matrix,beg,end,height,(int)(width-1),pnf);
               SetVector(VolByPrice,beg,end,v[i]);
               VolByCol[width-1]=0;
               VolByCol[width-1]=VolByCol[width-1]+v[i];
               DateByCol[width-1]=d[i];
               tMin[width-1]=beg-1;
               tMax[width-1]=end+1;
               break;
              };
            break;
           };
        };
     };


// startX - shift for prices
//-- BMP image size on the chart display
   int XSize=cellsize*width+2*startX;
   int YSize=cellsize*height;
//-- creating a bmp image sized XSizexYSize with the background color clrSeashell
   bmp.Create(XSize,YSize,clrWhite);
//-- drawing the border
//   bmp.DrawRectangle(0,0,XSize-1,YSize-1,clrBlack);

   for(i=height-1;i>=0;i--)
      for(j=0;j<=width-1;j++)
         bmp.DrawRectangle(startX+cellsize*j,cellsize*i,startX+cellsize*(j+1),cellsize*(i+1),clrLightGray);

   s="BSD License, FXRays.info by Roman Rich";
   FileWrite(handle,s);  Print("259:",s);//added
   i=0;                                                               //Calculating trend lines
   while(thEnd<width-1)
     {
      while(thBeg+i<thEnd)
        {
         if(trend=='U')
           {
            i=ArrayMinimum(tMin,thBeg,thEnd-thBeg);
            j=tMin[i];
           }
         else
           {
            i=ArrayMaximum(tMax,thBeg,thEnd-thBeg);
            j=tMax[i];
           }
         thBeg=i;
         tv=j;
         i=0;
         while(GetMatrix(matrix,j,height,(long)(thBeg+i))=='.')
           {
            i++;
            if(trend=='U') j++; else j--;
            if(thBeg+i==width-1)
              {
               thEnd=width-1;
               break;
              };
           };
         if(thBeg+i<thEnd)
           {
            thBeg=thBeg+2;
            i=0;
           };
        };
      thEnd=thBeg+i;
      if(thEnd==thBeg) thEnd++;
      for(i=thBeg;i<thEnd;i++)
        {
         SetMatrix(matrix,tv,tv,height,(long)(i),'+');
         //         if(trend=='U') { bmp.TypeText(startX+i*cellsize,tv*cellsize,"U",clrGreen); }
         //         if(trend=='D') { bmp.TypeText(startX+i*cellsize,tv*cellsize,"D",clrRed); }
         //--- support and resistance lines
         if(trend=='U') { bmp.DrawLine(startX+i*cellsize,tv*cellsize,startX+(i+1)*cellsize,(tv+1)*cellsize,clrGreen); }
         if(trend=='D') { bmp.DrawLine(startX+i*cellsize,(tv+1)*cellsize,startX+(i+1)*cellsize,(tv)*cellsize,clrRed); }

         //--- this is just the broadening of support/resistance lines
         if(trend=='U') { bmp.DrawLine(1+startX+i*cellsize,tv*cellsize,1+startX+(i+1)*cellsize,(tv+1)*cellsize,clrGreen); }
         if(trend=='D') { bmp.DrawLine(1+startX+i*cellsize,(tv+1)*cellsize,1+startX+(i+1)*cellsize,(tv)*cellsize,clrRed); }
         if(trend=='U') { bmp.DrawLine(2+startX+i*cellsize,tv*cellsize,2+startX+(i+1)*cellsize,(tv+1)*cellsize,clrGreen); }
         if(trend=='D') { bmp.DrawLine(2+startX+i*cellsize,(tv+1)*cellsize,2+startX+(i+1)*cellsize,(tv)*cellsize,clrRed); }

         if(trend=='U') tv++; else tv--;

        };
      if(trend=='U') trend='D'; else trend='U';
      i=0;
     };

   ArrayResize(strDBC,width,0);                                       //Displaying dates in columns
   TimeToStruct(DateByCol[0],bMDT);
   TimeToStruct(DateByCol[width-1],eMDT);
   if((DateByCol[width-1]-DateByCol[0])>=50000000)
     {
      for(i=0;i<=width-1;i++) StringInit(strDBC[i],4,' ');
      for(i=1;i<=width-1;i++)
        {
         TimeToStruct(DateByCol[i-1],bMDT);
         TimeToStruct(DateByCol[i],eMDT);
         if(bMDT.year!=eMDT.year) strDBC[i]=DoubleToString(eMDT.year,0);
        };
      for(i=0;i<=3;i++)
        {
         StringInit(s,vd,' ');
         s=s+"            : ";
         for(j=0;j<=width-1;j++) s=s+StringSubstr(strDBC[j],i,1);
         s=s+" : ";
         FileWrite(handle,s);    Print("322:",s);//added
        };
     }
   else
     {
      if((DateByCol[width-1]-DateByCol[0])>=5000000)
        {
         for(i=0;i<=width-1;i++) StringInit(strDBC[i],7,' ');
         for(i=1;i<=width-1;i++)
           {
            TimeToStruct(DateByCol[i-1],bMDT);
            TimeToStruct(DateByCol[i],eMDT);
            if(bMDT.mon!=eMDT.mon)
              {
               if(eMDT.mon<10) strDBC[i]=DoubleToString(eMDT.year,0)+".0"+DoubleToString(eMDT.mon,0);
               if(eMDT.mon>=10) strDBC[i]=DoubleToString(eMDT.year,0)+"."+DoubleToString(eMDT.mon,0);
              }
           };
         for(i=0;i<=6;i++)
           {
            StringInit(s,vd,' ');
            s=s+"            : ";
            for(j=0;j<=width-1;j++) s=s+StringSubstr(strDBC[j],i,1);
            s=s+" : ";
            FileWrite(handle,s);        Print("346:",s," i=",i);//added
           };
        }
      else
        {
         for(i=0;i<=width-1;i++) StringInit(strDBC[i],10,' ');
         for(i=1;i<=width-1;i++)
           {
            TimeToStruct(DateByCol[i-1],bMDT);
            TimeToStruct(DateByCol[i],eMDT);
            if(bMDT.day!=eMDT.day)
              {
               if(eMDT.mon<10 && eMDT.day<10) strDBC[i]=DoubleToString(eMDT.year,0)+".0"+DoubleToString(eMDT.mon,0)+".0"+DoubleToString(eMDT.day,0);
               if(eMDT.mon<10 && eMDT.day>=10) strDBC[i]=DoubleToString(eMDT.year,0)+".0"+DoubleToString(eMDT.mon,0)+"."+DoubleToString(eMDT.day,0);
               if(eMDT.mon>=10&&eMDT.day< 10) strDBC[i]=DoubleToString(eMDT.year,0)+"." +DoubleToString(eMDT.mon,0)+".0"+DoubleToString(eMDT.day,0);
               if(eMDT.mon>=10&&eMDT.day>=10) strDBC[i]=DoubleToString(eMDT.year,0)+"." +DoubleToString(eMDT.mon,0)+"." +DoubleToString(eMDT.day,0);
              }
           };
         for(i=0;i<=9;i++)
           {
            StringInit(s,vd,' ');
            s=s+"            : ";
            for(j=0;j<=width-1;j++) s=s+StringSubstr(strDBC[j],i,1);
            s=s+" : ";
            FileWrite(handle,s);         Print("370:",s," i=",i);//added   
           };
        };
     };
   StringInit(s,25+vd+width,'-');
   FileWrite(handle,s);     Print("375:",s);//added   
   price=GlobalMax*dBox;                                              //Displaying price chart
   VolumeMax=VolByPrice[ArrayMaximum(VolByPrice,0,WHOLE_ARRAY)];
   s="";               Print("!: 378: height=",height," price=",price," dbox=",dBox," width=",width); //added


   bmp.DrawLine(startX,0,startX,cellsize*(height),clrGray);
   bmp.DrawLine(XSize-startX,0,XSize-startX,cellsize*(height),clrGray);


   for(i=height-1;i>=0;i--)
     {
      StringInit(ps,8-StringLen(DoubleToString(price,sd)),' ');
      s=s+ps+DoubleToString(price,sd)+" : ";
      for(j=0;j<vd;j++) if(VolByPrice[i]>VolumeMax*j/vd) s=s+"*"; else s=s+" ";
      s=s+" : ";
      for(j=0;j<=width-1;j++) s=s+CharToString(matrix[j*height+i]);

      bmp.TypeText(10,cellsize*i,DoubleToString(price,_Digits-1),clrBlack);
      bmp.DrawLine(0,cellsize*i,startX,cellsize*i,clrLightGray);
      bmp.DrawLine(startX-3,cellsize*i,startX+3,cellsize*i,clrBlack);

      bmp.TypeText(XSize-startX+10,cellsize*i,DoubleToString(price,_Digits-1),clrBlack);
      bmp.DrawLine(XSize-startX,cellsize*i,XSize,cellsize*i,clrLightGray);
      bmp.DrawLine(XSize-startX-3,cellsize*i,XSize-startX+3,cellsize*i,clrBlack);


      for(j=0;j<=width-1;j++)
        {
         if(CharToString(matrix[j*height+i])=="X")
           {
            ShowBitMask(startX+cellsize*j+1,cellsize*i+1,1);
           }
         else
         if(CharToString(matrix[j*height+i])=="O")
           {
            ShowBitMask(startX+cellsize*j+1,cellsize*i+1,2);
           }
        }

      s=s+" : "+ps+DoubleToString(price,sd);
      FileWrite(handle,s);            //  Print("387:",s," i=",i);//added   
      s="";
      price=price-dBox;
     };
   StringInit(s,25+vd+width,'-');
   FileWrite(handle,s);                 Print("392:",s);//added   
   StringInit(s,vd,' ');                                              //Simple markup through 10
   s=s+"            : ";
   for(j=0;j<=width-1;j++) if(StringGetCharacter(DoubleToString(j,0),StringLen(DoubleToString(j,0))-1)==57) s=s+"|"; else s=s+" ";
   s=s+" : ";
   FileWrite(handle,s);                  Print("397:",s);//added    
   VolumeMax=VolByCol[ArrayMaximum(VolByCol,0,WHOLE_ARRAY)];          //Displaying volume chart in columns
   for(i=vd-1;i>=0;i--)
     {
      StringInit(s,vd,' ');
      s=s+"            : ";
      for(j=0;j<=width-1;j++) if(VolByCol[j]>VolumeMax*i/vd) s=s+"*"; else s=s+" ";
      s=s+" : ";
      FileWrite(handle,s);            Print("405:",s," i=",i);//added 
     };
   StringInit(s,25+vd+width,'-');
   FileWrite(handle,s);                    Print("408:",s);//added      
   s="     | Start Date/Time     | End Date/Time       | ";           //Column history
   FileWrite(handle,s);                     Print("410:",s);//added      
   TimeToStruct(DateByCol[0],bMDT);
   s="   1 | 0000/00/00 00:00:00 | ";
   s=s+DoubleToString(bMDT.year,0)+"/";
   if(bMDT.mon >=10) s=s+DoubleToString(bMDT.mon ,0)+"/"; else s=s+"0"+DoubleToString(bMDT.mon ,0)+"/";
   if(bMDT.day >=10) s=s+DoubleToString(bMDT.day ,0)+" "; else s=s+"0"+DoubleToString(bMDT.day ,0)+" ";
   if(bMDT.hour>=10) s=s+DoubleToString(bMDT.hour,0)+":"; else s=s+"0"+DoubleToString(bMDT.hour,0)+":";
   if(bMDT.min >=10) s=s+DoubleToString(bMDT.min ,0)+":"; else s=s+"0"+DoubleToString(bMDT.min ,0)+":";
   if(bMDT.sec >=10) s=s+DoubleToString(bMDT.sec ,0)+" | "; else s=s+"0"+DoubleToString(bMDT.sec ,0)+" | ";
   FileWrite(handle,s);              Print("419:",s);//added      
   for(i=1;i<=width-1;i++)
     {
      TimeToStruct(DateByCol[i-1],bMDT);
      TimeToStruct(DateByCol[i],eMDT);
      s="";
      StringInit(ps,4-StringLen(DoubleToString(i+1,0)),' ');
      s=s+ps+DoubleToString(i+1,0)+" | ";
      s=s+DoubleToString(bMDT.year,0)+"/";
      if(bMDT.mon >=10) s=s+DoubleToString(bMDT.mon ,0)+"/"; else s=s+"0"+DoubleToString(bMDT.mon ,0)+"/";
      if(bMDT.day >=10) s=s+DoubleToString(bMDT.day ,0)+" "; else s=s+"0"+DoubleToString(bMDT.day ,0)+" ";
      if(bMDT.hour>=10) s=s+DoubleToString(bMDT.hour,0)+":"; else s=s+"0"+DoubleToString(bMDT.hour,0)+":";
      if(bMDT.min >=10) s=s+DoubleToString(bMDT.min ,0)+":"; else s=s+"0"+DoubleToString(bMDT.min ,0)+":";
      if(bMDT.sec >=10) s=s+DoubleToString(bMDT.sec ,0)+" | "; else s=s+"0"+DoubleToString(bMDT.sec ,0)+" | ";
      s=s+DoubleToString(eMDT.year,0)+"/";
      if(eMDT.mon >=10) s=s+DoubleToString(eMDT.mon ,0)+"/"; else s=s+"0"+DoubleToString(eMDT.mon ,0)+"/";
      if(eMDT.day >=10) s=s+DoubleToString(eMDT.day ,0)+" "; else s=s+"0"+DoubleToString(eMDT.day ,0)+" ";
      if(eMDT.hour>=10) s=s+DoubleToString(eMDT.hour,0)+":"; else s=s+"0"+DoubleToString(eMDT.hour,0)+":";
      if(eMDT.min >=10) s=s+DoubleToString(eMDT.min ,0)+":"; else s=s+"0"+DoubleToString(eMDT.min ,0)+":";
      if(eMDT.sec >=10) s=s+DoubleToString(eMDT.sec ,0)+" | "; else s=s+"0"+DoubleToString(eMDT.sec ,0)+" | ";
      FileWrite(handle,s);          // Print("439:",s," i=",i);//added      
     };
   FileClose(handle);
//-- saving the resulting image in a file  
   bmp.Save("bmpimg",true);
//-- displaying it
   bmp.Show(0,0,"bmpimg","PF");
   Sleep(2000);

   Alert(fn);  
  }
//+------------------------------------------------------------------+
//|Adjusting the price to the box size                                     |
//+------------------------------------------------------------------+
int MathNorm(double value,                                           //Transforming any double-type figure into long-type figure,...
             double prec,                                            //...ensuring the necessary accuracy...
             bool vect)                                              //...and if true, rounding up; if false, rounding down
  {
   if(vect==true)
      return((int)(MathCeil(value/prec)));
   else
      return((int)(MathFloor(value/prec)));
  }
//+------------------------------------------------------------------+
//|Filling the array                                                  |
//+------------------------------------------------------------------+
//Character one-dimensional array represented as a matrix,...
void SetMatrix(uchar& array[],                                      //...passing the array in a link to effect a replacement...
               long pbeg,                                           //...from here...
               long pend,                                           //...up to here...
               long pheight,                                        //...in the column of this height...
               long pwidth,                                         //...bearing this number among all the columns in the array...
               uchar ppnf)                                          //...with this character
  {
   long offset=0;
   for(offset=pheight*pwidth+pbeg;offset<=pheight*pwidth+pend;offset++) array[(int)offset]=ppnf;
  }
//+------------------------------------------------------------------+
//|Getting an isolated value from the array                            |
//+------------------------------------------------------------------+
//Character one-dimensional array represented as a matrix,...
uchar GetMatrix(uchar& array[],                                      //...passing it in a link to obtain a character...
                long pbeg,                                           //...here...
                long pheight,                                        //...in the column of this height...
                long pwidth)                                         //...bearing this number among all the columns in the array
  {
   return(array[(int)pheight*(int)pwidth+(int)pbeg]);
  }
//+------------------------------------------------------------------+
//|Filling the vector                                                  |
//+------------------------------------------------------------------+
void SetVector(long &array[],//passing the long-type array in a link to effect a replacement...
               long pbeg,                                           //...from here...
               long pend,                                           //...up to here...
               long pv)                                             //...with this value
  {
   long offset=0;
   for(offset=pbeg;offset<=pend;offset++) array[(int)offset]=array[(int)offset]+pv;
  }
//+------------------------------------------------------------------+
